//////////////////////////////////////////////////////////////////////////
#include "servo.h"
#include <avr/io.h>
#include <avr/interrupt.h>

//////////////////////////////////////////////////////////////////////////
//Variablen
char isr_check=0;
float servo_pos=162;
char position[5];

//////////////////////////////////////////////////////////////////////////
// Servo Initialisierung
void servo_init(void)
{
	SERVO_DDR |= 1<<SERVO_PIN;			//Ausgang fr Servo aktivieren
	
	TCCR0 |= 1<<CS02;					// -> Prescaler 256
	TIMSK |= 1<<TOIE0;					// Interrupt bei Overflow von Timer0
	
	sei();								// Interrupts aktivieren			
}

//////////////////////////////////////////////////////////////////////////
// Servo Ansteuerung -- Position in s (1000..2000)
void servo(unsigned int pos)
{
	servo_pos=256-((double)0.0625*pos);			//-> 0.0625 = F_CPU [in MHz]/256
}


ISR(TIMER0_OVF_vect)
{
	if(isr_check==0)			//Zwischen den beiden ISR wechseln
	{
		SERVO_PORT &= ~(1<<SERVO_PIN);			//Servo Pin LOW setzen
		TCCR0 |= 1<<CS00;						//Prescaler 1024 -> ca 61Hz
		TCNT0=0;								//Vorladung von 0
		
		isr_check++;		
	}
	else
	{
		SERVO_PORT |= 1<<SERVO_PIN;				//Servo Pin HIGH setzen
		TCCR0 &= ~(1<<CS00);					//Prescaler 256
		TCNT0=servo_pos;
		isr_check=0;
	}
	
}